/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/

package cdac.medinfo.sdk.dcm30_04.services.implanttemplate.testcases.CMovecu;

import cdac.medinfo.sdk.dcm30_04.baselibs.DataSet;
import cdac.medinfo.sdk.dcm30_04.baselibs.ImplicitDE;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.enums.EnumLoggingLevel;
import cdac.medinfo.sdk.dcm30_04.enums.EnumPDUType;
import cdac.medinfo.sdk.dcm30_04.services.association.AAbort;
import cdac.medinfo.sdk.dcm30_04.services.association.AReleaseRQorRP;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociateRQ;
import cdac.medinfo.sdk.dcm30_04.services.association.DefaultAssociation;
import cdac.medinfo.sdk.dcm30_04.services.cmove.commons.CMoveRQ;
import cdac.medinfo.sdk.dcm30_04.services.cmove.commons.CMoveRSP;
import cdac.medinfo.sdk.dcm30_04.services.cmove.scu.CMoveSCU;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumServiceType;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.DicomMessage;
import cdac.medinfo.sdk.dcm30_04.services.scu.commons.SCUSession;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.ISingleCollection;

/**
 * This class is implemented to test the C-Move operation of ImplantTemplate SCU using CMoveSCU class of SDK for DICOM.
 * In order to run the following class , please refer to this link($Link) to create the environment.
 * To implement an SCU of a particular we need to do the following things:
 * Create the SCUSession object which maintains the current session of the SCU. Its "start" method accepts
 * the SCP's IP Address and Port and tries to establish a connection with the SCP. 
 * Some ways to create an Association Request: 
 *  1)Use Default Association class to Load the association for requested service. User can load the association 
 * by specifying the Service Type in loadAssociation method of Default association. For e.g. here EnumServiceType.CMOVE
 * should be specified to load Association for C-Move Services. The association request for C-Move 
 * is made according to  jars in the class path.
 * 2) Manually create object of AssociationRQ class and set all presentation contexts collection on it. 
 * More details provided in the API DOCS of AssociationRQ class.

 * After successful association is established the SCUSession stores the status of the Association with it.  
 * Create C-Move object to send the C-Move Request to the respective SCP. Currently the "sendMessage" method 
 * of the CMove would wait after sending the C-Move-RQ until a suitable DIMSE response is received. 
 * When CMove request is send to the server with key attribute which is to be moved then for the Destination AE Title
 * specified in the CMove request, the C-Move Server should perform the CStore with third party and sends 
 * response to SCU. This operation is part of Synchronous mode request handling.  
 * Once the DIMSE response is received by the CMoveSCU it stores it into its collection
 * which then can be retrieved.
 * 
 * After this, create a A-Release-RQ in order to request for association release and send it using the
 * SCUSession object. This is again a blocking call and the SCUSession waits until a A-Release-RP is received.
 * At the end of an operation calling "close" on SCUSession would disconnect the connection made with the 
 * SCP and release all the acquired resources.
 * 
 * Instead of closing the session after a C-Move operation is complete,we can create another association
 * and send more requests. 
 * Also it is possible to create multiple C-Move-RQs and send them one by one on the same Association.
 */
public class ImplantTemplate_SCU 
{
	public static void main(String[] args)
	{
		try
		{
			DicomConfig objDicomConfig = DicomConfig.createInstance();

			//enable logging,specify the path of the directory where log files are created.
			//User can specify any directory in place of 'c:\DCM_Logs'.
			//		If no directory is defined by user to create logs then it is created in User Temp DIR.
			objDicomConfig.enableLogging(EnumLoggingLevel.INFO, "C:/DCM_Logs");

			/*
			 * Creates instance of CMove_SCU and start CMove SCU operation.
			 */
			ImplantTemplate_SCU objTestCMoveSCU = new ImplantTemplate_SCU();
			objTestCMoveSCU.start();
		}
		catch(Exception e)
		{
			e.printStackTrace();	
		}
	}

	/**
	 * Start C-Move SCU.
	 */
	public void start()
	{
		//SCUSession 
		SCUSession objSession = null;

		try
		{
			//Create SCUSession object
			objSession = new SCUSession();

			/*
			 * Setting time out as 5000 milli second. It will wait 5000 mili seconds for read and write operation.
			 * If in the time specified (5000 ms) read or write operation is not performed then 
			 * session is time out.
			 */ 
			//objSession.setTimeOut(5000);

			/*
			 * Initializes the service types and populates the default association
			 */
			EnumServiceType[] arrenumServiceType = new EnumServiceType[1];
			arrenumServiceType[0] = EnumServiceType.CMOVE_IMPLANTTEMPLATE;
			DefaultAssociation objDefaultAssociation = new DefaultAssociation("SDK");
			objDefaultAssociation.loadAssociation(arrenumServiceType);

			//Create Association RQ
			AssociateRQ objAssociateRQ = objDefaultAssociation.getAssociationRQ("SDK");

			//Start SCU Session by providing the IP address and Port of SCP.
			objSession.start("localhost", 9000);

			//Create CStore SCU object using the current SCU Session.
			CMoveSCU objCMoveSCU = new CMoveSCU(objSession);

			//Send the Association Request
			if(objSession.sendAssociationMessage(objAssociateRQ))
			{

				//When association is successfully established the "objSession.sendAssociationMessage()"
				//method returns true.

				System.out.println("Association is established");

				/*
				 * Creating DataSet for C-Move Request.
				 */
				IDataSet objIDataSet = new DataSet();
				IDictionaryReader objIDictionaryReader = objIDataSet.getDictionaryReader();

				objIDataSet.addDataElement(getDataElement(0x0000,0x0002, null, objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0000,0x0120, null, objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0000,0x0800, null, objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0008,0x0016, "1.2.840.10008.5.1.4.45.1", objIDictionaryReader));
				objIDataSet.addDataElement(getDataElement(0x0008,0x0018, "1.2.3.4.5.6.7.1.2", objIDictionaryReader));

			

				//Create Default CMove RQ by giving the parsed DataSet. This method uses
				// default values for the attributes in the request. These attributes can be
				//modified once the request object is created, before sending.
				CMoveRQ objCMoveRQ = CMoveRQ.getDefaultRQ("1.2.840.10008.5.1.4.43.3", "DCMRCV", objIDataSet);

				//Send the C-Move-RQ and wait for a C-Move-RSP with status not pending
				//This method exits once the response is received. This response is 
				//added in the response collection maintained by the CStoreSCU which
				//can be retrieved. This method return true if request is successfully sent 
				//to the SCP and false if the message cannot be sent to the SCP( for e.g. if 
				//the association status is false or if SOP class UID is not agreed in agreed association.
				if(objCMoveSCU.sendMessage(objCMoveRQ))
				{
					System.out.println("C-Move opearation performed");
					ISingleCollection<DicomMessage> objSingleCollection = objCMoveSCU.getDIMSEResponse();
					System.out.println("Size of Response collection :: " + objSingleCollection.size());
					/*
					 * This will get the pending response from the Dicom Message and displays it.
					 */
					for(DicomMessage objDicomMessage : objSingleCollection)
					{
						CMoveRSP objCMoveRSP = new CMoveRSP(objDicomMessage);
						System.out.println("Response Status  :" + Integer.toHexString(objCMoveRSP.getStatus()));
					}
				}
				else
					System.out.println("C-Move operation failed");

				//Create A-Release-RQ to release the association
				AReleaseRQorRP objAReleaseRQorRP = new AReleaseRQorRP(EnumPDUType.RELEASE_RQ);

				//Send the A-Release-RQ
				if(objSession.sendAssociationMessage(objAReleaseRQorRP))
				{
					System.out.println("Assocaition is released");
					//When successful A-Release-RP is received, close the Session.
					//Please note that instead of closing the session we can create 
					//another association and send more requests. Also it is possible
					//to create multiple C-Move-RQs and send them one by one.
					objSession.close();
				}

				//In case an ABORT is received from SCP during the C-Store operation
				if(objSession.getDIMSEAssociation() instanceof AAbort)
				{
					System.out.println("Abort arrives. Closing session.");
					objSession.close();
				}
			}
			else
			{
				System.out.println("Associaiton cannot be established");
				objSession.close();
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
			objSession.close();
		}
	}
	/*
	 * Get the data element belonging to the information provided
	 */
	private IDataElement getDataElement(int GroupNo,int ElementNo,Object objVal,IDictionaryReader objDictionaryReader)
	{
		IDataElement objIDataElement = new ImplicitDE(GroupNo, ElementNo,objVal,objDictionaryReader);
		return objIDataElement;
	}
}
